/*
 * Rewriter
 *
 * Author: Micah Jones
 * Adviser: Dr. Kevin Hamlen
 *
 * This is the Main entry point of the program.
 *
 */

package checkpolicy.main;

import spox.policy.*;

import checkpolicy.*;

/**
 *
 * @author Micah Jones
 */
public class Main
{
    
    // Constructor
    public Main()
    {
    }
    
    // Main entry point
    public static void main(String[] args)
    {
        if (args.length == 0)
            MainForm.main(new String[0]);
        else if (args.length == 1)
            checkPolicy(args[0]);
        else
            System.out.println("Usage: CheckPolicy [filename]\n");
    }

    public static void checkPolicy(String filename)
    {
        try
        {
//            long[] times = new long[10];
//            for (int i = 0; i < 10; i++)
//            {
                long t1 = System.currentTimeMillis();

                // Generate the policy
                Policy policy = new Policy();
                policy.openPolicyFile(filename);

                // Check the policy
                String returnMessage = Analysis.checkPolicy(policy);
                System.out.println(returnMessage);

                long t2 = System.currentTimeMillis();
                System.out.println((t2-t1)+" ms");
//                times[i] = t2-t1;
//            }
//            long sumTimes = 0;
//            for (int i = 0; i < 10; i++)
//                sumTimes = sumTimes + times[i];
//            long avgTimes = sumTimes/10;
//            System.out.println("\nAvg. time: " + avgTimes);
        }
        catch (org.xml.sax.SAXException e)
        {
            e.printStackTrace();
//            JOptionPane.showMessageDialog(this,
//                    "XML Parse Error:\n" + e.getMessage(), "XML Error",
//                    JOptionPane.ERROR_MESSAGE);
        }
        catch (Exception e)
        {
            e.printStackTrace();
//            JOptionPane.showMessageDialog(this,
//                    "ERROR:\n" + e.getMessage(), "Error",
//                    JOptionPane.ERROR_MESSAGE);
        }
    }
    
}
