package checkpolicy.util;

public class PairTuple<T1,T2>
{

    @Override
    public boolean equals(Object obj)
    {
        if (obj == null)
        {
            return false;
        }
        if (getClass() != obj.getClass())
        {
            return false;
        }
        final PairTuple<T1, T2> other = (PairTuple<T1, T2>) obj;
        if (this.first != other.first && (this.first == null || !this.first.equals(other.first)))
        {
            return false;
        }
        if (this.second != other.second && (this.second == null || !this.second.equals(other.second)))
        {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode()
    {
        int hash = 3;
        hash = 41 * hash + (this.first != null ? this.first.hashCode() : 0);
        hash = 41 * hash + (this.second != null ? this.second.hashCode() : 0);
        return hash;
    }

    public T1 first;
    public T2 second;
    
    /**
     * Constructs a new 2-tuple with the given data values.
     * @param first The first element.
     * @param second The second element.
     */
    public PairTuple(T1 first, T2 second)
    {
        this.first = first;
        this.second = second;
    }

    /**
     * Switches the two elements of the pair and returns the result as
     * a new tuple.
     * @return The flipped pair.
     */
    public PairTuple<T2,T1> flipPair()
    {
        return new PairTuple<T2,T1>(this.second,this.first);
    }
}
