package checkpolicy.util;

public class TripleTuple<T1,T2,T3>
{

    @Override
    public boolean equals(Object obj)
    {
        if (obj == null)
        {
            return false;
        }
        if (getClass() != obj.getClass())
        {
            return false;
        }
        final TripleTuple<T1, T2, T3> other = (TripleTuple<T1, T2, T3>) obj;
        if (this.first != other.first && (this.first == null || !this.first.equals(other.first)))
        {
            return false;
        }
        if (this.second != other.second && (this.second == null || !this.second.equals(other.second)))
        {
            return false;
        }
        if (this.third != other.third && (this.third == null || !this.third.equals(other.third)))
        {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode()
    {
        int hash = 3;
        hash = 97 * hash + (this.first != null ? this.first.hashCode() : 0);
        hash = 97 * hash + (this.second != null ? this.second.hashCode() : 0);
        hash = 97 * hash + (this.third != null ? this.third.hashCode() : 0);
        return hash;
    }


    public T1 first;
    public T2 second;
    public T3 third;
    
    /**
     * Constructs a new 3-tuple with the given data values.
     * @param first The first element.
     * @param second The second element.
     * @param third The third element.
     */
    public TripleTuple(T1 first, T2 second, T3 third)
    {
        this.first = first;
        this.second = second;
        this.third = third;
    }
}
